// Singleton.h

#ifndef SINGLETON_H
#define SINGLETON_H

#include <stdio.h> // for NULL...

namespace sbr
{

template <class T>
class Singleton
{
public:
    static T* instance();
    static void deleteInstance();
    virtual bool init();
protected:
    Singleton();
    virtual ~Singleton();
private:
    Singleton(const Singleton& rh);
    Singleton<T>& operator = (const Singleton<T>& rh);
    static T* _instance;
};

template <class T>
T* Singleton<T>::_instance = NULL;

template <class T>
inline Singleton<T>::Singleton()
{
}

template <class T>
inline Singleton<T>::~Singleton()
{
}

template <class T>
inline T* Singleton<T>::instance()
{
        if (_instance == NULL) {
            _instance = new T();
        }
    return _instance;
}

template <class T>
inline void Singleton<T>::deleteInstance()
{
        if (_instance != NULL) {
            delete _instance;
            _instance = NULL;
        }
}

template <class T>
inline bool Singleton<T>::init()
{
	return true;
}

}; //namespace

#endif // SINGLETON_H
